/* 
   Palette routines
   --------------------------------------------------------------------
   Linberto

   Copyright (C) 1999-2001 Diego Javier Grigna <diego@grigna.com>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "common.h"

static struct {
         unsigned char r; /* Red   */
         unsigned char g; /* Green */
         unsigned char b; /* Blue  */
       } gamepal[] = {
{  0,  0,  0},
{  1,  1,  1},
{  2,  2,  2},
{  3,  3,  3},
{  4,  4,  4},
{  6,  6,  6},
{  7,  7,  7},
{  8,  8,  8},
{  9,  9,  9},
{ 11, 11, 11},
{ 12, 12, 12},
{ 13, 13, 13},
{ 14, 14, 14},
{ 16, 16, 16},
{ 17, 17, 17},
{ 18, 18, 18},
{ 19, 19, 19},
{ 21, 21, 21},
{ 22, 22, 22},
{ 23, 23, 23},
{ 24, 24, 24},
{ 25, 25, 25},
{ 27, 27, 27},
{ 28, 28, 28},
{ 29, 29, 29},
{ 30, 30, 30},
{ 32, 32, 32},
{ 33, 33, 33},
{ 34, 34, 34},
{ 35, 35, 35},
{ 37, 37, 37},
{ 38, 38, 38},
{ 39, 39, 39},
{ 40, 40, 40},
{ 42, 42, 42},
{ 43, 43, 43},
{ 44, 44, 44},
{ 45, 45, 45},
{ 46, 46, 46},
{ 48, 48, 48},
{ 49, 49, 49},
{ 50, 50, 50},
{ 51, 51, 51},
{ 53, 53, 53},
{ 54, 54, 54},
{ 55, 55, 55},
{ 56, 56, 56},
{ 58, 58, 58},
{ 59, 59, 59},
{ 60, 60, 60},
{ 61, 61, 61},
{ 63, 63, 63},
{  0,  0,  0},
{  0,  0,  2},
{  0,  0,  5},
{  0,  0,  7},
{  0,  0, 10},
{  0,  0, 12},
{  0,  0, 15},
{  0,  0, 17},
{  0,  0, 20},
{  0,  0, 22},
{  0,  0, 25},
{  0,  0, 27},
{  0,  0, 30},
{  0,  0, 32},
{  0,  0, 35},
{  0,  0, 37},
{  0,  0, 40},
{  0,  0, 42},
{  0,  0, 45},
{  0,  0, 47},
{  0,  0, 50},
{  0,  0, 52},
{  0,  0, 55},
{  0,  0, 57},
{  0,  0, 60},
{  0,  0, 63},
{  2,  2, 63},
{  5,  5, 63},
{  7,  7, 63},
{ 10, 10, 63},
{ 12, 12, 63},
{ 15, 15, 63},
{ 17, 17, 63},
{ 20, 20, 63},
{ 22, 22, 63},
{ 25, 25, 63},
{ 27, 27, 63},
{ 30, 30, 63},
{ 32, 32, 63},
{ 35, 35, 63},
{ 37, 37, 63},
{ 40, 40, 63},
{ 42, 42, 63},
{ 45, 45, 63},
{ 47, 47, 63},
{ 50, 50, 63},
{ 52, 52, 63},
{ 55, 55, 63},
{ 57, 57, 63},
{ 60, 60, 63},
{ 63, 63, 63},
{  0,  0,  0},
{  0,  2,  0},
{  0,  4,  0},
{  0,  7,  0},
{  0,  9,  0},
{  0, 12,  0},
{  0, 14,  0},
{  0, 16,  0},
{  0, 19,  0},
{  0, 21,  0},
{  0, 24,  0},
{  0, 26,  0},
{  0, 29,  0},
{  0, 31,  0},
{  0, 33,  0},
{  0, 36,  0},
{  0, 38,  0},
{  0, 41,  0},
{  0, 43,  0},
{  0, 46,  0},
{  0, 48,  0},
{  0, 50,  0},
{  0, 53,  0},
{  0, 55,  0},
{  0, 58,  0},
{  0, 60,  0},
{  0, 63,  0},
{  2, 63,  2},
{  5, 63,  5},
{  7, 63,  7},
{ 10, 63, 10},
{ 12, 63, 12},
{ 15, 63, 15},
{ 17, 63, 17},
{ 20, 63, 20},
{ 22, 63, 22},
{ 25, 63, 25},
{ 27, 63, 27},
{ 30, 63, 30},
{ 32, 63, 32},
{ 35, 63, 35},
{ 37, 63, 37},
{ 40, 63, 40},
{ 42, 63, 42},
{ 45, 63, 45},
{ 47, 63, 47},
{ 50, 63, 50},
{ 52, 63, 52},
{ 55, 63, 55},
{ 57, 63, 57},
{ 60, 63, 60},
{ 63, 63, 63},
{  0,  0,  0},
{  2,  0,  0},
{  4,  0,  0},
{  7,  0,  0},
{  9,  0,  0},
{ 12,  0,  0},
{ 14,  0,  0},
{ 16,  0,  0},
{ 19,  0,  0},
{ 21,  0,  0},
{ 24,  0,  0},
{ 26,  0,  0},
{ 29,  0,  0},
{ 31,  0,  0},
{ 33,  0,  0},
{ 36,  0,  0},
{ 38,  0,  0},
{ 41,  0,  0},
{ 43,  0,  0},
{ 46,  0,  0},
{ 48,  0,  0},
{ 50,  0,  0},
{ 53,  0,  0},
{ 55,  0,  0},
{ 58,  0,  0},
{ 60,  0,  0},
{ 63,  0,  0},
{ 63,  2,  2},
{ 63,  5,  5},
{ 63,  7,  7},
{ 63, 10, 10},
{ 63, 12, 12},
{ 63, 15, 15},
{ 63, 17, 17},
{ 63, 20, 20},
{ 63, 22, 22},
{ 63, 25, 25},
{ 63, 27, 27},
{ 63, 30, 30},
{ 63, 32, 32},
{ 63, 35, 35},
{ 63, 37, 37},
{ 63, 40, 40},
{ 63, 42, 42},
{ 63, 45, 45},
{ 63, 47, 47},
{ 63, 50, 50},
{ 63, 52, 52},
{ 63, 55, 55},
{ 63, 57, 57},
{ 63, 60, 60},
{ 63, 63, 63},
{  0,  0,  0},
{  2,  2,  0},
{  5,  5,  0},
{  7,  7,  0},
{ 10, 10,  0},
{ 13, 13,  0},
{ 15, 15,  0},
{ 18, 18,  0},
{ 21, 21,  0},
{ 23, 23,  0},
{ 26, 26,  0},
{ 28, 28,  0},
{ 31, 31,  0},
{ 34, 34,  0},
{ 36, 36,  0},
{ 39, 39,  0},
{ 42, 42,  0},
{ 44, 44,  0},
{ 47, 47,  0},
{ 49, 49,  0},
{ 52, 52,  0},
{ 55, 55,  0},
{ 57, 57,  0},
{ 60, 60,  0},
{ 63, 63,  0},
{ 63, 63,  2},
{ 63, 63,  5},
{ 63, 63,  7},
{ 63, 63, 10},
{ 63, 63, 13},
{ 63, 63, 15},
{ 63, 63, 18},
{ 63, 63, 21},
{ 63, 63, 23},
{ 63, 63, 26},
{ 63, 63, 28},
{ 63, 63, 31},
{ 63, 63, 34},
{ 63, 63, 36},
{ 63, 63, 39},
{ 63, 63, 42},
{ 63, 63, 44},
{ 63, 63, 47},
{ 63, 63, 49},
{ 63, 63, 52},
{ 63, 63, 55},
{ 63, 63, 57},
{ 63, 63, 60},
{ 63, 63, 63},
};

void palette_init( void)
{
 int i;

 for( i = 0; i < 256; i++)
      vga_setpalette( i, gamepal[ i].r, gamepal[ i].g, gamepal[ i].b);
}

void palette_set_brightness( void)
{
 int i, r, g, b;

 for( i = 0; i < 256; i++) {
      r = gamepal[ i].r + bright;
      g = gamepal[ i].g + bright;
      b = gamepal[ i].b + bright;

      if( r < 0) r = 0;
      if( g < 0) g = 0;
      if( b < 0) b = 0;

      if( r > 63) r = 63;
      if( g > 63) g = 63;
      if( b > 63) b = 63;

      vga_setpalette( i, r, g, b);
 }
}

